/*
detail.js
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: detail.js,v 1.8 2010/06/07 13:31:20 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/




function showhide(layer_ref) {

  var bt = document.getElementById(layer_ref + "_bt");
  var hza = document.getElementById(layer_ref);
  if (bt.class == 'minus') {
    hza.style.display = 'none';
    bt.src = 'plus.gif';
    bt.class = 'plus';
  } else {
    hza.style.display = 'block';
    bt.src = 'minus.gif';
    bt.class = 'minus';
  }
}

function elementToList(element) {
	var ret='<li><b>' + element.tagName + ': </b>';
	if (element.firstChild) {
		ret = ret + element.firstChild.nodeValue;
	}
	ret = ret + '</li>';
	return ret;
}

function detail(type, id) {
  var tr = document.getElementById(id);
  var img = document.getElementById("img_" + id);
  var nbCols = tr.getElementsByTagName('td').length;
  var tableId;
  var phpDetail;
  var phpParam;
  switch (type) {
    case "channel":
      tableId="channels";
      phpDetail="channeldetail.php";
      phpParam="channel";
      break;
    case "job":
    case "activejob":
    case "endedjob":
      tableId=type + "detail";
      phpDetail="jobdetail.php";
      phpParam="jobid";
      break;
    case "file":
      tableId="jobdetail";
      phpDetail="filedetail.php";
      phpParam="fileid";
      break;
  }
  //var thisTr = tr.getElementsByTagName('td')[0];
  var tbl = document.getElementById(tableId);
  if (img.class == 'minus') {
		img.class = 'plus';
		img.src = 'plus.gif';
		tbl.deleteRow(tr.rowIndex+1);
	} else {
		img.src = 'minus.gif';
		img.class = 'minus';
		var row = tbl.insertRow(tr.rowIndex+1);
		row.innerHTML = '<td id="det-' + id + '" colspan="' + nbCols + '">Retrieving ' + phpParam + ' details...</td>';
		xhr = new XMLHttpRequest();
		xhr.open('POST', phpDetail, true);
		xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		xhr.onreadystatechange = function() {
			if (xhr.readyState == 4) {
				if (xhr.status == 200) {
					var answer = xhr.responseXML.documentElement;
					fields = answer.childNodes;
					var fieldsStr = '<ul>';
					for (var i = 0; i < fields.length; i++){
						if (fields[i].tagName == 'detail') {
							details = fields[i].childNodes;
							for (var j=0; j< details.length; j++) {
								fieldsStr = fieldsStr + elementToList(details[j]);
							}
						} else if (fields[i].tagName == 'list') {
							items=fields[i].childNodes;
							for (var j=0; j<items.length; j++) {
								fieldsStr = fieldsStr + '<li>Transfer<ul>';
								item=items[j].childNodes;
								for (var k=0; k<item.length; k++) {
									fieldsStr = fieldsStr + elementToList(item[k]);
								}
								fieldsStr = fieldsStr + '</ul></li>';
							}
							
						} else {
							fieldsStr = fieldsStr + elementToList(fields[i]);
						}
					} 
					fieldsStr = fieldsStr + '</ul>';
					row.innerHTML = '<td colspan="' + nbCols + '">' + fieldsStr + '</td>';
				} else {
					row.innerHTML = '<td colspan="' + nbCols + '">ERROR</td>';
				}
			}
		};
		xhr.send('type=xml&' + phpParam + '=' + id);
	}
}
function channeldetail(channelid) {
  detail("channel", channelid);
}
function jobdetail(jobid) {
  detail("job", jobid);
}
function activejobdetail(jobid) {
  detail("activejob", jobid);
}
function endedjobdetail(jobid) {
  detail("endedjob", jobid);
}
function filedetail(fileid) {
  detail("file", fileid);
}
