<?php
/*
fts.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: fts.php,v 1.10 2010/05/27 12:50:10 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

include('ftsheader.php');

if (strpos($_SERVER['HTTP_USER_AGENT'], 'Safari')) {
  echo '<script language="JavaScript" type="text/javascript" src="detail-safari.js">';
} else {
  echo '<script language="JavaScript" type="text/javascript" src="detail.js">';
}
echo '</script>';

try {
  echo '<div class="filter">';
  $channels = array($ftsm->conf->siteName=>$ftsm->conf->siteName,FTS_STAR=>'*',FTS_OTHER=>'Other',FTS_ALL=>'All');
  if (array_key_exists('to', $_GET)) {
    $to = $_GET['to'];
    if ($to != $ftsm->conf->siteName and $to != FTS_STAR and $to != FTS_OTHER and $to != FTS_ALL) {
      throw new InvalidInputException("to=$to");
    }
  }
  if (!isset($to)) $to = FTS_ALL;


  if (array_key_exists('from', $_GET)) {
    $from = $_GET['from'];
    if ($from != $ftsm->conf->siteName and $from != FTS_STAR and $from != FTS_OTHER and $from != FTS_ALL) {
      throw new InvalidInputException("from=$from");
    }
  }
  if (!isset($from)) $from = FTS_ALL;

  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';

  echo 'Filter from <select name="from" onChange="javascript:this.form.submit();">';
  foreach ($channels as $table => $label) {
    printf ("<option value=\"%s\" %s>%s", $table, ($table == $from)?"selected":"", $label);
  }
  echo '           </select>';

  echo ' To <select name="to" onChange="javascript:this.form.submit();">';
  foreach ($channels as $table => $label) {
    printf ("<option value=\"%s\" %s>%s", $table, ($table == $to)?"selected":"", $label);
  }
  echo '           </select>';

  echo ' for VO ';
  print ($ftsm->conf->voToHTML($vo));
  echo '    <input type="submit">';
  echo '</form>';
  echo '</div>';



//$query = "select T_CHANNEL.CHANNEL_NAME, SOURCE_SITE || ' => ' || DEST_SITE \"BETWEEN\", NOSTREAMS as STREAMS, NOFILES as FILES, CHANNEL_STATE ";
$query = "select T_CHANNEL.CHANNEL_NAME, SOURCE_SITE as \"FROM\", DEST_SITE as \"TO\", NOSTREAMS as STREAMS, NOFILES as FILES, CHANNEL_STATE ";
if ($ftsm->conf->currentSchema >= "3.2.0") {
      $query .= ", decode(TRANSFER_TYPE, 'URLCOPY', URLCOPY_TX_TO, SRMCOPY_TO) as TIMEOUT ";
}
//$query .= ", T_CHANNEL.CONTACT ";
if ($vo != FTS_ALL) {
  $query .= " , " . $ftsm->conf->connSchema . "T_CHANNEL_VO_SHARE.CHANNEL_SHARE ";
}
$query .= " from " . $ftsm->conf->connSchema . "T_CHANNEL, " . $ftsm->conf->connSchema . "T_AGENT ";
if ($vo != FTS_ALL) {
  $query .= ", " . $ftsm->conf->connSchema . "T_CHANNEL_VO_SHARE ";
}
$query .= " where T_AGENT.AGENT_NAME = concat('channel:',T_CHANNEL.CHANNEL_NAME) ";
if ($vo != FTS_ALL) {
  $query .= " and " . $ftsm->conf->connSchema . "T_CHANNEL_VO_SHARE.CHANNEL_NAME = " . $ftsm->conf->connSchema . "T_CHANNEL.CHANNEL_NAME and " . $ftsm->conf->connSchema . "T_CHANNEL_VO_SHARE.VO_NAME = '" . $vo . "' ";
}
if ($from != FTS_ALL) {
  if ($from == $ftsm->conf->siteName || $from == FTS_STAR) {
    $query .= " and SOURCE_SITE = '" . $from . "' ";
  } else {
    $query .= " and SOURCE_SITE != '" . $ftsm->conf->siteName . "' and SOURCE_SITE != '*' ";
  }
}
if ($to != FTS_ALL) {
  if ($to == $ftsm->conf->siteName || $to == FTS_STAR) {
    $query .= " and DEST_SITE = '" . $to . "' ";
  } else {
    $query .= " and DEST_SITE != '" . $ftsm->conf->siteName . "' and DEST_SITE != '*' ";
  }
}

$query .= " order by CHANNEL_NAME";

    $ftsq->setQuery($query);
    $r = $ftsq->execute();
    echo '<div class="principale">';
    $r->display('channels',True);
    echo '</div>';
} catch (Exception $e) {
  die('<span class="' . FTS_CSS_CLASS_ALERT . '">ERROR: --' . $e->getMessage() . '--</span>');
}
footer();
?>