<?php
/*
ftsagent.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftsagent.php,v 1.8 2010/06/07 12:41:21 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

require_once('ftsheader.php');

try {
  echo '<div class="filter">';
  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';

  $host = trim($_GET['host']);
  if (preg_match('/^[a-zA-Z0-9._-]*$/', $host) != 1) throw new InvalidInputException("not a valid agent host: $host"); 
  $type = $_GET['type'];
  if (!isset($type)) $type = 'all';
  if ($type != 'channel' and $type != 'vo' and $type != 'all') throw new InvalidInputException("not a valid agent type: $type");
  printf ("Filter by agent host: <input width=\"10\" type=\"text\" name=\"host\" onChange=\"javascript:this.form.submit();\" value=\"%s\">", $host);
  printf(" type <select name=\"type\" onChange=\"javascript:this.form.submit();\">");
  printf("<option value=\"all\" %s>All</option>", $type=='all'?'selected':'');
  printf("<option value=\"channel\" %s>Channel</option>", $type=='channel'?'selected':'');
  printf("<option value=\"vo\" %s>VO</option>", $type=='vo'?'selected':'');
  echo "</select>";

?>
    <input type="submit">
</form>
</div>

<?php
    $query = "select AGENT_HOST, AGENT_NAME, AGENT_STATE, LAST_ACTIVE, AGENT_VERSION, CONTACT from " . $ftsm->conf->connSchema . "T_AGENT ";
    $andwhere = " where ";
    if (isset($host)) {
        $query .= $andwhere . " AGENT_HOST like '%" . $host . "%' ";
        $andwhere = " and ";
    }
    if ($type != 'all') {
        $query .= $andwhere . " AGENT_TYPE = '" . $type ."' ";
    }
    $query .= " order by AGENT_HOST, AGENT_NAME";
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
    echo '<br><center>';
    echo '<div class="principale">';
    $r->display($id='agentlist');
    echo '</center>';
    echo '</div>';
} catch (Exception $e) {
  die('<span class="' . FTS_CSS_CLASS_ALERT . '">ERROR: --' . $e->getMessage() . '--</span>');
}
footer();
?>