<?php
/*
ftschannel.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftschannel.php,v 1.28 2010/06/07 12:44:39 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

//$ftsdebug=True;
require_once('ftsheader.php');

if (strpos($_SERVER['HTTP_USER_AGENT'], 'Safari')) {
  echo '<script language="JavaScript" type="text/javascript" src="detail-safari.js">';
} else {
  echo '<script language="JavaScript" type="text/javascript" src="detail.js">';
}
echo '</script>';

?>

<?php
try {
  echo '<div class="filter">';
  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';

  $channel = $_GET['channel'];
  if (!isset($channel)) $channel=FTS_NONE;
  if (isset($channel) && !isValidChannel($channel)) {
    throw new InvalidInputException("not a valid channel name: $channel");
  }
  echo 'Filter by ';
  $cl = new ChannelList();
  $cl->addNone();
  print ($cl->toHTML($channel));
  echo ' for VO ';
  print ($ftsm->conf->voToHTML($vo));
?>
    <input type="submit">
</form>
</div>
<?php
  if (isset($channel) and $channel != FTS_NONE) { 
?>

<div class="principale">
  <h3><img id="configuration_bt" class="plus" src="plus.gif" onclick="showhide('configuration');">Channel configuration</h3>
  <div id="configuration" style="display: none">
    <div class="secondaire">
      <?php  channelconfig(); ?>
    </div>
    <div class="secondaire">
      <?php  voshare(); ?>
    </div>
    <div class="secondaire">
      <?php  managers(); ?>
    </div>
  </div>
</div>

<div class="principale">
  <h3><img id="statistics_bt" class="plus" src="plus.gif" onclick="showhide('statistics');">Transfers statistics</h3>
  <div id="statistics"  style="display: none">
    <div class="secondaire">
      <h4>Jobs (last 14 days)</h4>
      <?php  jobstats(); ?>
    </div>
    <div class="secondaire">
      <h4>Files (number transferred per hour during last 24h)</h4>
      <?php    files(); ?>
    </div>
  </div>
</div>

<div class="principale">
  <h3><img id="err_statistics_bt" class="plus" src="plus.gif" onclick="showhide('err_statistics');">Errors statistics</h3>
  <div id="err_statistics"  style="display: none">
    <div class="secondaire">
      <h4>Main errors (last 24 hours)</h4>
      <?php  errstats(); ?>
    </div>
  </div>
</div>


<?php
 } //ENDIF Channel is not None
?>

<div id="jobs" class="principale">
  <h3>Current jobs</h3>

  <?php  jobs();?>
</div>

<div id="endedjobs" class="principale">
  <h3>Ended jobs (finished in the last 24 hours)</h3>

  <?php  endedjobs();?>
</div>

<?php
} catch (Exception $e) {
  die('<span class="' . FTS_CSS_CLASS_ALERT . '">ERROR: --' . $e->getMessage() . '--</span>');
}

function channelconfig() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $query = "select SOURCE_SITE, DEST_SITE, T_CHANNEL.CONTACT, NOSTREAMS, NOFILES, CHANNEL_STATE, T_CHANNEL.LAST_ACTIVE, ADMIN_DN, AGENT_HOST ";
    if ($ftsm->conf->currentSchema >= "3.2.0") {
      $query .= ", TRANSFER_TYPE, decode(TRANSFER_TYPE, 'URLCOPY', URLCOPY_TX_TO, SRMCOPY_TO) as TRANSFER_TIMEOUT, TCP_BUFFER_SIZE ";
      if ($ftsm->conf->currentSchema >= "3.3.0") {
        $query .= ", TX_TO_PER_MB ";
      }
    }
    $query .= " from " . $ftsm->conf->connSchema . "T_CHANNEL, " . $ftsm->conf->connSchema . "T_AGENT where AGENT_NAME = 'channel:" . $channel . "' AND CHANNEL_NAME = '" . $channel . "'";
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
 //   ftsSyslog(sprintf("EXECUTED %s IN %d s\n", $query, $ftsq->duration),LOG_DEBUG);
    if ($r->getNbRows() == 0) {
      throw new Exception( "This channel does not exist: $channel");
    }
    $channelFound = $r->getFirstRow();
    //print "<ul>";
    printf("Between <b>%s</b> and <b>%s</b>", $channelFound['SOURCE_SITE'], $channelFound['DEST_SITE']);
    $g = $ftsm->getGroup($channelFound['SOURCE_SITE']);
    if (!is_null($g)) {
        print $g->toHTML();
    }
    $g = $ftsm->getGroup($channelFound['DEST_SITE']);
    if (!is_null($g)) {
        print $g->toHTML();
    }
    printf("<br><b>%s</b> concurrent files on <b>%s</b> streams each", $channelFound['NOFILES'], $channelFound['NOSTREAMS']);
    printf("<br>TCP buffer size: <b>%s</b>", $channelFound['TCP_BUFFER_SIZE']);
    if ($ftsm->conf->currentSchema >= "3.2.0") {
      $toVariable = '';
      if ($ftsm->conf->currentSchema >= "3.3.0") {
        $toVariable = $channelFound['TX_TO_PER_MB'] != ''?
		" + " . $channelFound['TX_TO_PER_MB'] . " s/MB"
		:"";
      }
      printf("<br>Transfer timeout (%s): <b>%s sec %s</b>\n", 
	$channelFound['TRANSFER_TYPE'], 
	($channelFound['TRANSFER_TIMEOUT'] != ''?$channelFound['TRANSFER_TIMEOUT']:"NOT DEFINED"),
        $toVariable);
    }
    printf("<br>The channel is <b>%s</b>", $channelFound['CHANNEL_STATE']);
    printf("<br>Agent running on <b>%s</b>", $channelFound['AGENT_HOST']);
    printf("<br><a href=\"ftsaudit.php?channel=%s\">Go to history of channel management</a>", $channel);
}

function voshare() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    if ($ftsm->conf->currentSchema >= "3.2.0") {
      $selectWhat = " CHANNEL_SHARE, CHANNEL_LIMIT, CHANNEL_VOSTATE ";
    } else {
      $selectWhat = " CHANNEL_SHARE ";
    }
    if ($vo == FTS_ALL) {
      $selectWhat = " VO_NAME, " . $selectWhat;
    }
    $query = "select " . $selectWhat . "  from " . $ftsm->conf->connSchema . "T_CHANNEL_VO_SHARE where CHANNEL_NAME = '" . $channel . "' ";
    if ($vo != FTS_ALL) {
      $query .= " and VO_NAME = '" . $vo . "'";
    } else {
      $query .= " order by VO_NAME";
    }
    //print $query;
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
  //  ftsSyslog(sprintf("EXECUTED %s IN %d s\n", $query, $ftsq->duration), LOG_DEBUG);
    $r->display();
}

function managers() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $query = "select PRINCIPAL as CHANNEL_MANAGERS from " . $ftsm->conf->connSchema . "T_CHANNEL_ACL where CHANNEL_NAME = '" . $channel . "'";
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
    $r->display();
}

function errstats() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $concat = "t_transfer.error_scope || ' / ' || t_transfer.error_phase || ' / ' || t_transfer.reason_class";
    $query = "select count(" . $concat . ") as nb_errors, " . $concat . " AS ERROR_TYPE  from " . $ftsm->conf->connSchema . "t_transfer, " . $ftsm->conf->connSchema . "t_job, " . $ftsm->conf->connSchema . "t_file where t_file.finish_time between (sysdate - 1) and sysdate and t_transfer.job_id = t_job.job_id and t_transfer.job_id = t_file.job_id and t_file.job_id = t_job.job_id  and t_transfer.transfer_state = '" . FTS_STATE_FAILED . "'  and channel_name = '" . $channel . "'";
    if ($vo != FTS_ALL) {
        $query .= " and VO_NAME = '" . $vo . "' ";
    }
    $query .= " group by (" . $concat . ") order by nb_errors desc";
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
    $r->setMaxLines(5);
    $r->display();
}

function jobstats() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    if ($vo != FTS_ALL) {
        $query = "select JOB_STATE, count(JOB_ID) as NUMBER_OF_JOBS from " . $ftsm->conf->connSchema . "T_JOB where CHANNEL_NAME = '" . $channel . "' and VO_NAME = '" . $vo . "' and SUBMIT_TIME between (sysdate - 14) and sysdate group by JOB_STATE order by JOB_STATE";
    } else {
        $query = "select JOB_STATE, count(JOB_ID) as NUMBER_OF_JOBS from " . $ftsm->conf->connSchema . "T_JOB where CHANNEL_NAME = '" . $channel . "' and SUBMIT_TIME between (sysdate - 14) and sysdate group by JOB_STATE order by JOB_STATE";
    }
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
    echo "<table cellpadding=\"2\" border=\"1\">\n";
    print "<TR>";
    print "<th class=\"layout\" width=\"50%\">";
    foreach ($ftsm->getStates() as $state) {
      printf("<span class=\"%s\"> %s </span>", $state, $state);
    }
    print "</th></TR>\n";
      
    $current_channel = new ChannelStat($channel);
    foreach ($r->getAllRows() as $row) {
        $current_channel->setStat($row['JOB_STATE'], (int)($row['NUMBER_OF_JOBS']));
    }
    printf( "<TR><TD>%s</TD></TR>", $current_channel->toString());
    echo "</TR></table>\n";
}

function endedjobs() {
  jobs(False);
}

function jobs($active=True) {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $query = "select T_JOB.JOB_ID, T_JOB.SUBMIT_TIME, decode(CANCEL_JOB, 'Y', '" . FTS_STATE_CANCELING . "', JOB_STATE) AS JOB_STATE, FILE_STATE, ";
    if ($vo == FTS_ALL) {
        $query .= " VO_NAME, ";
    }
    $query .= " SOURCE_SE, DEST_SE, STORAGE_CLASS ";
    $query .= " from " . $ftsm->conf->connSchema . "T_JOB, " . $ftsm->conf->connSchema . "T_FILE ";
    if (isset($channel) and $channel != FTS_NONE) {
        $query .= " where CHANNEL_NAME = '" . $channel . "' ";
    } else {
        $query .= " where CHANNEL_NAME is null";
    }
    $query .= " and T_JOB.JOB_ID = T_FILE.JOB_ID ";
    if ($vo != FTS_ALL) {
         $query .= " and VO_NAME = '" . $vo . "' ";
    }
    $activeStates="('" . FTS_STATE_READY . "','" . FTS_STATE_ACTIVE . "')";
    if ($active) {
      //$query .= " and JOB_STATE in $activeStates ";
      $query .= " and T_JOB.JOB_FINISHED is null ";
      $query .= " order by SUBMIT_TIME desc";
    } else {
      //$query .= " and JOB_STATE not in $activeStates ";
      $query .= " and (T_JOB.JOB_FINISHED > sysdate - 1)";
      //$query .= " and (SUBMIT_TIME > sysdate - 1)";
      $query .= " order by T_JOB.JOB_FINISHED desc";
    }
    $ftsq->setQuery($query);
    //print $query;
    $r = $ftsq->execute(-1);

    $jdr = new FTS_JobDetailsResult($r->getAllRows());
    // the ID of the table is either "activejobdetail" or "endedjobdetail"
    $jdr->display($active?"activejobdetail":"endedjobdetail");
}

function files() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $query = "select TO_CHAR(T_FILE.FINISH_TIME,'HH24') as h from " . $ftsm->conf->connSchema . "T_JOB, " . $ftsm->conf->connSchema . "T_FILE ";
    $query .= " where T_FILE.FINISH_TIME > (sysdate - 1) ";
    $query .= " and T_FILE.FILE_STATE = '" . FTS_STATE_FINISHED . "'";
    if ($vo != FTS_ALL) {
         $query .= " and VO_NAME = '" . $vo . "' ";
    }
    $query .= " and T_JOB.CHANNEL_NAME = '" . $channel . "' ";
    $query .= " and T_FILE.JOB_ID = T_JOB.JOB_ID ";
    $query .= " order by T_FILE.FINISH_TIME";
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
    $results = $r->getAllRows();
    $nrows = $r->getNbRows();
    // store results in Array: nbFiles["0"=>12, "1"=>25...]
    $nbFiles = Array();
    // Init this array with 0
    for ($i = 0; $i < 24; $i++) {
      $nbFiles[] = 0;
    }
    foreach ($results as $row) {
      $nbFiles[(int)$row['H']]++;
    }
    echo "<table><tr>";
    $currenthour = date('H') - 2; //FTS is 2hour late
    for ($i = $currenthour; $i <= 23; $i++) {
        printf("<th>%02d</th>", $i);
    }
    for ($i = 0; $i < $currenthour; $i++) {
        printf("<th>%02d</th>", $i);
    }
    echo "<th>Total</th></tr>\n";
    // print files transfers statistics
    echo "<tr>";
    for ($i = $currenthour; $i <= 23; $i++) {
        printf("<td>%d</td>", $nbFiles[$i]);
    }
    for ($i = 0; $i < $currenthour; $i++) {
        printf("<td>%d</td>", $nbFiles[$i]);
    }
    printf("<td>%d</td>\n", $nrows);
    echo "</tr></table>\n";

}
echo '</div>';
footer();
?>