<?php
/*
ftserrors.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftserrors.php,v 1.5 2010/05/19 13:36:53 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

class InvalidInputException extends Exception {
  public function __construct($userinput, $message="Invalid input data") {
    ftsSyslog($userinput, LOG_ERR);
    parent::__construct($message);
  }
  public function __toString() {
    return "Invalid input data";
  }
}

  function formatError($v) {
    //$formatted = str_replace('"', '', $v);
    //$formatted = str_replace('#', '', $formatted);
    //return htmlentities($formatted);
    return htmlentities($v);
  }
  function formatErrorTruncated($v) {
    $limit=200;
    if (strlen($v) < $limit) return $v;
    $formatted = substr($v,0,$limit/2) . " ... " . substr($v,strlen($v)-$limit/2);
    return $formatted;
  }
  function formatErrorDisplay($v) {
    $limit=200;
    if (strlen($v) < $limit) $formatted = $v;
    else $formatted = substr($v,0,$limit/2) . " ... " . substr($v,strlen($v)-$limit/2);
    $formatted = str_replace('"', '', $formatted);
    return htmlentities($formatted);
  }
  function formatErrorLink($v) {
    $formatted = str_replace('"', '', $v);
    $formatted = str_replace('#', '', $formatted);
    $formatted = str_replace('<', '(', $formatted);
    $formatted = str_replace('>', ')', $formatted);
    $formatted = str_replace(' ','_', $formatted);
    return $formatted;
  }

  class Error {
    public function __construct($re_desc, $explain) {
      $this->re_desc = $re_desc;
      $this->explain = $explain;
    }
  }

  function getErrorsCsv($file) {
    $errors = Array();
    if (is_readable($file) and ($handle = fopen($file, "r")) !== FALSE) {
      while (($data = fgetcsv($handle, 1000, ";")) !== FALSE) {
        if ($data[0] != '' and $data[0][0] != '#') {
          $errors[] = new Error(strtolower($data[0]), $data[1]);
        }
      }
      fclose($handle);
    }
    return $errors;
  }
?>
