<?php
/*
ftsheader.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftsheader.php,v 1.14 2010/05/04 07:40:25 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

require_once('ftsinit.php');

try {

init();
// Check VO in cookie
$vocookiename='ftsmonitor_vo';
$vo = $_GET['vo'];

//if (! isset($vo))  $vo = FTS_ALL;

if (isset($vo)) {
  if (!$ftsm->conf->isKnownVo($vo)) {
    $vo= FTS_ALL;
  } else {
    if (! isset($_COOKIE[$vocookiename])) {
      setcookie($vocookiename, $vo, time()+3600*24*1000);
    } else {
      if ($_COOKIE[$vocookiename] != $vo) {
        setcookie($vocookiename, $vo, time()+3600*24*1000);
      }
    }
  }
} else {
  if (isset($_COOKIE[$vocookiename])) {
    if (!$ftsm->conf->isKnownVo($_COOKIE[$vocookiename])) {
      $vo = FTS_ALL;
    } else {
      $vo = $_COOKIE[$vocookiename];
    }
  } else {
    $vo = FTS_ALL;
  }
}


print "<html>";
print "<head>";
printf("<LINK href=\"%s\" rel=\"stylesheet\" type=\"text/css\">", $ftsm->conf->css);
printf("<META http-equiv=\"refresh\" content=\"%d\">", $ftsm->conf->refresh);
print "</head>";
print "<body bgcolor=\"#FFFFFF\">";
print "<center><span class=\"date\">";

printf ("[<a href=\"ftsmonitor.php\">Home</a>] %s - last updated: %s (updated every %d seconds) ",
	$ftsm->__toString(),
	date("d/m/Y H:i:s"),
	$ftsm->conf->refresh);

  $cachefile = 'latestnews';
  $result = null;
  try {
    $result = ftsCacheRead($cachefile,7200);
  } catch (Exception $e) {
    $curl_session = curl_init();
    curl_setopt($curl_session, CURLOPT_URL, "https://forge.in2p3.fr/projects/ftsmonitor/news?format=atom");
    curl_setopt($curl_session, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl_session, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($curl_session, CURLOPT_SSL_VERIFYHOST, 0);
    $result = curl_exec($curl_session);
    $curl_error = curl_errno($curl_session);
    if ($result === false) {
      ftsSyslog(sprintf("Could not retrieve latest news: result=%s, errno=%d", $result, $errno),
			LOG_WARNING);
      $result = null;
    } else {
      ftsCacheWrite($cachefile, $result);
    }
    curl_close($curl_session);
  }
  if (! is_null($result)) {
    $dom = new DOMDocument();
    if ($dom->loadXML($result)) {
      $lastnews = $dom->getElementsByTagname('entry')->item(0);
      if (!is_null($lastnews)) {
        $lastnews_epoch = strtotime($lastnews->getElementsByTagname('updated')->item(0)->nodeValue); // format: 2010-03-19T18:03:53+01:00
        // if latest news is older than 1 month do not print it
        if (time() - $lastnews_epoch < 3600*24*30) {
          $lastnews_title = $lastnews->getElementsByTagname('title')->item(0)->nodeValue;
          $lastnews_link = $lastnews->getElementsByTagname('id')->item(0)->nodeValue;
          printf( " [<a href=\"%s\">%s</a>]", 
//		strftime('%x', $lastnews_epoch), 
		$lastnews_link, 
		$lastnews_title);
        }
      } else {
        ftsSyslog(sprintf("Latest news is not ATOM format: %s...", substr($result,0,15), $errno),
			LOG_WARNING);
      }
    }
  }
print "</span></center>";

if (! in_array($ftsm->conf->currentSchema, $ftsm->getSupportedSchemas())) {
        print "<center><span class=\"date\">WARNING: The DB Schema version (" . $ftsm->conf->currentSchema . ") is not supported by this ftsmonitor release, you may encounter problems</span></center>";
}
  
} catch (Exception $e) {
  die('ERROR: --' . $e->getMessage() . '--');
}

function footer($vo=FTS_ALL) {
print "<div class=\"footer\"><span class=\"date\">";

printf ("[ <a href=\"ftsmonitor.php\">Home</a> | ");
echo "<a href=\"fts.php";
if ($vo != FTS_ALL) echo "?vo=" . $vo;
echo "\">Channels</a> | ";

echo '<a href="ftsagent.php">Agents</a> | ';
echo '<a href="ftsaudit.php">Channels audit</a> | ';
echo '<a href="ftsabout.php">About</a> ]';

print "</span></div>";

print "</body>";
print "</html>";

}
?>
