<?php
/*
ftsinit.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftsinit.php,v 1.10 2010/05/27 13:32:56 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

openlog("ftsmonitor", LOG_PERROR, LOG_LOCAL0);

require_once('ftsconstants.php');
require_once('ftsmonitor.classes.php');
require_once('ftserrors.php');
require_once('ftsutils.php');
require_once('ftsdb.classes.php');

function init() {
//try {
//global $conn;
//global $currentschema;
//global $conf;
  global $ftsq;
  global $ftsm;
  global $ftsconn;

  // clear cache directory
  try {
   ftsCacheClear();
  } catch (Exception $e) {
   ftsSyslog($e->getMessage(), LOG_ERROR);
  }

  // Create global FTSMonitor object
  $ftsq = new FTSPDOQuery();

  $cache = 'cache/ftsmonitor';
  $expire = time()-3600;

  if (file_exists($cache) && filemtime($cache)>$expire) {
    //$ftsm->conf->currentSchema = file_get_contents($cache);
    $ftsm = unserialize(file_get_contents($cache));
    $ftsconn = new FTSPDO($ftsm->conf->connString, $ftsm->conf->connLogin, $ftsm->conf->connPwd);
  } else {
    $ftsm = new FTSMonitor();
    $ftsconn = new FTSPDO($ftsm->conf->connString, $ftsm->conf->connLogin, $ftsm->conf->connPwd);

    // Get schema version from database
    $query = "select major || '.' || minor || '.' || patch as SCHEMA from " .   $ftsm->conf->connSchema . "T_SCHEMA_VERS";
    $ftsq->setQuery($query);
    $results = $ftsq->execute(86400);
    $line1 = $results->getFirstRow();
    $ftsm->conf->currentSchema = $line1['SCHEMA'];

    // get site groups from database
    $query = "select GROUP_NAME, SITE_NAME from " .   $ftsm->conf->connSchema . "T_SITE_GROUP order by GROUP_NAME, SITE_NAME";
    $ftsq->setQuery($query);
    $results = $ftsq->execute(86400);

    foreach ($results->getAllRows() as $r) {
        $ftsm->addSiteGroup($r['GROUP_NAME'],$r['SITE_NAME']);
    }

    $serial_ftsm = serialize($ftsm);
    file_put_contents($cache, $serial_ftsm);
  }
}

?>
