<?php
/*
ftsjob.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftsjob.php,v 1.20 2010/06/07 12:29:47 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

require_once('ftsheader.php');
if (strpos($_SERVER['HTTP_USER_AGENT'], 'Safari')) {
  echo '<script language="JavaScript" type="text/javascript" src="detail-safari.js">';
} else {
  echo '<script language="JavaScript" type="text/javascript" src="detail.js">';
}
echo '</script>';

?>

<?php
try {
  echo '<div class="filter">';
  $jobid = $_GET['jobid'];
  if (!isValidJobId($jobid)) {
    throw new InvalidInputException("Not a valid job id: $jobid");
  }
  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';
  echo 'Job identifier: <input name="jobid" value="' . $jobid . '" size="40">';
  echo ' <input type="submit">';
  echo '</form>';
  echo '</div>';
   if (isset($jobid)) { 
    echo "<h3>Job information</h3>";
    /*$query = "select SUBMIT_TIME, JOB_STATE, CHANNEL_NAME, SPACE_TOKEN, STORAGE_CLASS";
    $query .= ", REASON from " . $ftsm->conf->connSchema . "T_JOB where JOB_ID = '" . $jobid . "' ";
    $ftsq->setQuery($query);
    $r = $ftsq->execute();*/
    $query = "select SUBMIT_TIME, JOB_STATE, CHANNEL_NAME, SPACE_TOKEN, STORAGE_CLASS";
    $query .= ", REASON from " . $ftsm->conf->connSchema . "T_JOB where JOB_ID = :jobid ";
    $stmt = $ftsconn->prepare($query);
    $stmt->bind('jobid', $jobid);
    $r = $stmt->execute();
    if ($r->getNbRows() == 0)
      throw new Exception("This job does not exist ");
    $f1 = $r->getFirstRow();
    if ($f1['REASON'] == '') {
        $r->hide('REASON');
    }
    $r->display();

    echo "<h3>File transfers</h3>";
    $query = "select t.request_id, f.file_id, f.source_surl as source_file, f.filesize, round(decode(TX_DURATION, 0, 0, BYTES_WRITTEN/TX_DURATION)) AS THROUGHPUT, f.file_state, t.transfer_time as last_transfer_time, t.transfer_state as last_transfer_state, t.reason as LAST_TRANSFER_ERROR, 'DUMMY' as LOG from " . $ftsm->conf->connSchema . "t_file f, " . $ftsm->conf->connSchema . "t_transfer t where f.file_id = t.file_id and f.job_id= '" . $jobid . "' and transfer_time = (select max(transfer_time) from " . $ftsm->conf->connSchema . "t_transfer t2 where t2.file_id = t.file_id)";
    //$query = "select t.request_id, f.file_id, f.source_surl as source_file, f.filesize, t.THROUGHPUT, f.file_state, t.transfer_time as last_transfer_time, t.transfer_state as last_transfer_state, t.reason as LAST_TRANSFER_ERROR, 'DUMMY' as LOG from " . $ftsm->conf->connSchema . "t_file f, " . $ftsm->conf->connSchema . "t_transfer t where f.file_id = t.file_id and f.job_id= '" . $jobid . "' and transfer_time = (select max(transfer_time) from " . $ftsm->conf->connSchema . "t_transfer t2 where t2.file_id = t.file_id)";
    $ftsq->setQuery($query);
    $r = $ftsq->execute(120);
    if ($r->getNbRows() == 0) { // nothing in T_TRANSFER, publishing T_FILE only
      $query = "select f.file_id, f.source_surl as source_file, f.filesize, f.file_state, REASON from " . $ftsm->conf->connSchema . "t_file f where f.job_id= '" . $jobid . "'";
      $ftsq->setQuery($query);
      $r = $ftsq->execute();
    }
    // Those columns display depending on various values
    $r->hide('REASON');
    $r->hide('LAST_TRANSFER_ERROR');
    $r->hide('THROUGHPUT');
    foreach ($r->getAllRows() as $row) {
        if ($row['REASON'] != '') $r->show('REASON');
        if ($row['LAST_TRANSFER_ERROR'] != '') $r->show('LAST_TRANSFER_ERROR');
        if ($row['FILE_STATE'] != 'Failed') $r->show('THROUGHPUT');
    }
    $r->hide('REQUEST_ID');
    $r->hide('LAST_TRANSFER_STATE');
    $r->hide('FILE_STATE');
    $r->display('jobdetail');
   }
} catch (Exception $e) {
  die('<span class="' . FTS_CSS_CLASS_ALERT . '">ERROR: --' . $e->getMessage() . '--</span>');
}
echo '</div>';
footer();
?>
