<?php
/*
ftsmonitor.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftsmonitor.php,v 1.23 2010/05/04 07:40:25 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

$start=time();
include('ftsheader.php');
ftsSyslog(sprintf("header took %d s", time()-$start), LOG_DEBUG);

if (strpos($_SERVER['HTTP_USER_AGENT'], 'Safari')) {
  echo '<script language="JavaScript" type="text/javascript" src="detail-safari.js">';
} else {
  echo '<script language="JavaScript" type="text/javascript" src="detail.js">';
}
echo '</script>';

?>

<?php
try {
  $timescale = $_GET['timescale'];
  if (!isset($timescale)) {
    $timescale = $ftsm->conf->timescale;
  } else {
    $timescale = $ftsm->conf->validateTimescale($timescale);
  }

  $errorsOnly = ($_GET['err'] == 'on');
  
  echo '<div class="filter">';

  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';
  echo "Filter jobs submitted in the last " . $ftsm->conf->timescalesToHTML($timescale);
  echo '  for VO ';
  print ($ftsm->conf->voToHTML($vo));
  echo '<INPUT TYPE="CHECKBOX" NAME="err" onChange="javascript:this.form.submit();"';
  if ($errorsOnly) echo ' checked';
  echo '>   Show failing channels only';
  echo '</form>';
  echo "</div>";
  //displayVOList($vo);


  $start = time();
  $r = null;
    $query = "select JOB_STATE, count(JOB_ID) as NUMBER_OF_JOBS from " . $ftsm->conf->connSchema . "T_JOB where JOB_STATE in ('" . implode("','",$ftsm->getStates()) . "') and ";
    if ($vo != FTS_ALL) {
      $query .= " VO_NAME = '" . $vo . "' and ";
    }
    $query .= " (SUBMIT_TIME > current_timestamp - INTERVAL '" . $timescale . "' hour) ";
    $query .= " group by job_state order by job_state";
//  try {
//    $r = ftsCacheReadQuery($query,$ftsm->conf->refresh);
//  } catch (Exception $e) {
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
//    ftsCacheWriteQuery($query,$r);
//  }  
  $total = new ChannelStat('TOTAL');
  foreach ($r->getAllRows() as $row) {
      $total->setStat($row['JOB_STATE'], (int)($row['NUMBER_OF_JOBS']));
  }

echo '<div class="centered">';
echo '<!--General table-->';
echo '<div class="principale">';
echo '<!--General line-->';
//echo '<tr>';
echo '<!--Stats Cell-->';
//echo '<td class="invisible" width="65%">';
echo '<div class="secondaire" width="65%">';
/*
echo "<h3>Jobs statistics (submitted last " . $ftsm->conf->timescalesToHTML($timescale) . ')';
echo '<INPUT TYPE="CHECKBOX" NAME="err" onChange="javascript:this.form.submit();"';
if ($errorsOnly) echo ' checked';
echo '>Show errors only';
echo '</form></h3>';
*/
  echo "<h3>Jobs statistics (submitted last $timescale h)</h3>";
  $r = null;
    $query = "select CHANNEL_NAME, JOB_STATE, count(JOB_ID) as COUNT from " . $ftsm->conf->connSchema . "T_JOB where JOB_STATE in ('" . implode("','",$ftsm->getStates()) . "') and CHANNEL_NAME is not null ";
    if ($vo != FTS_ALL) {
      $query .= " and VO_NAME = '" . $vo . "' ";
    }
    $query .= " and (SUBMIT_TIME > current_timestamp - INTERVAL '" . $timescale . "' hour) ";
    $query .= " group by CHANNEL_NAME, JOB_STATE order by CHANNEL_NAME, job_state";
//  try {
//    $r = ftsCacheReadQuery($query,$ftsm->conf->refresh);
//  } catch (Exception $e) {

    $ftsq->setQuery($query);
    $r = $ftsq->execute();

//    ftsCacheWriteQuery($query,$r);
//  }  
    echo "<table id=\"channels\" width=\"100%\">\n";
    print "<TR><th>CHANNEL</th><th class=\"layout\" width=\"80%\">";
    foreach ($ftsm->getStates() as $state) {
      //printf("<img src=\"%s.gif\" width=\"20\" height=\"10\"> %s / ", $state, $state);
      printf("<span><span class=\"%s\"> %s </span></span>", $state, $state);
    }
    print "</th></TR>\n";
    if (! $errorsOnly) {
      print "<tr><td>TOTAL</td>";
      printf("<TD class=\"layout\">%s</TD>", $total->toString());
      print "</tr>";
    }
    //print "<tr><th></th><th></th></tr>";
    
    //OCIFetchInto ($statement2, $row, OCI_ASSOC+OCI_RETURN_NULLS);
    $current_channel = null;
    //do {
    foreach ($r->getAllRows() as $row) {

        $channel = $row['CHANNEL_NAME'];
        if ($current_channel == null) {
            $current_channel = new ChannelStat($channel);
        } else if ($current_channel->name != $channel) {
          if ($current_channel->hasErrors() or ! $errorsOnly) {
            printf( "<TR id=\"%s\">",
		$current_channel->name);
	    printf("<TD><span><img class=\"plus\" id=\"img_%s\" onClick=\"javascript:channeldetail('%s');\" src=\"plus.gif\"></span>", 
		$current_channel->name, 
		$current_channel->name);
            printf( "<a href=\"ftschannel.php?channel=%s&vo=%s\">%s</a></TD>\n",
		$current_channel->name, 
		$vo, 
		$current_channel->name);
            printf( "<TD class=\"layout\">%s</TD></TR>\n",
		$current_channel->toString());
          }
            $current_channel = new ChannelStat($channel);
        }
        $current_channel->setStat($row['JOB_STATE'], (int)($row['COUNT']));
    }
    if ($r->getNbRows() > 0) {
      if ($current_channel->hasErrors() or ! $errorsOnly) {
        printf( "<TR id=\"%s\">", $current_channel->name);
        printf("<TD><span><img class=\"plus\" id=\"img_%s\" onClick=\"javascript.channeldetail('%s');\" src=\"plus.gif\"></span>",	 
		$current_channel->name, 
		$current_channel->name);
        printf ("<a href=\"ftschannel.php?channel=%s&vo=%s\">%s</a></TD>\n",
	        $current_channel->name, 
	        $vo, 
	        $current_channel->name);
        printf( "<TD class=\"layout\">%s</TD></TR>\n",
	        $current_channel->toString());
      }
    }
    
  $r = null;
    $query = "select JOB_STATE, count(JOB_ID) as COUNT from " . $ftsm->conf->connSchema . "T_JOB where JOB_STATE in ('" . implode("','",$ftsm->getStates()) . "') and CHANNEL_NAME is null ";
    if ($vo != FTS_ALL) {
      $query .= " and VO_NAME = '" . $vo . "' ";
    }
    $query .= " and (SUBMIT_TIME > current_timestamp - INTERVAL '" . $timescale . "' hour) ";
    $query .= " group by JOB_STATE order by job_state";
//  try {
//    $r = ftsCacheReadQuery($query,$ftsm->conf->refresh);
//  } catch (Exception $e) {

    $ftsq->setQuery($query);
    $r = $ftsq->execute();
//    ftsCacheWriteQuery($query,$r);
//  }  

    if ($r->getNbRows() > 0) {
      $nonAffected = new ChannelStat('NON ALLOCATED');
      foreach ($r->getAllRows() as $row) {
        $nonAffected->setStat($row['JOB_STATE'], (int)($row['COUNT']));
      }
      print "<tr><td><a href=\"ftschannel.php?channel=" . FTS_NONE . "\">$nonAffected->name</a><span class=\"bubble\">Here are jobs that failed before they had a chance to get into a channel</span></td>";
      printf("<TD class=\"layout\">%s</TD>", $nonAffected->toString());
      print "</tr>";
    }

    echo "</table>\n";
    ftsSyslog(sprintf("jobs table took %d s", time()-$start), LOG_DEBUG);

//echo '</td>';
echo '<!--End of Stats Cell-->';
echo '</div>';
echo '<!--Alerts cell-->';
//echo '<TD class="invisible" width="35%">';
echo '<div class="secondaire" with="35%">';
//echo '<!--Alerts table-->';
//echo '<table>';
echo '<!--Line for Inactive channels-->';
//echo '<tr><td class="invisible">';

echo '<h3>Alerts</h3>';
echo "<table id=\"alerts\">";

echo "<tr><th>";
    foreach (Array(FTS_ALERT_OK,FTS_ALERT_WARNING,FTS_ALERT_ERROR) as $state) {
      printf("<span><span class=\"%s\"> %s </span></span>", $state, $state);
    }
echo "</th></tr>";


$sensors=Array();
$alarms=Array();

$sensors[] = new FTSAgentSensor($vo);
$sensors[] = new FTSVoSensor($vo);
$sensors[] = new FTSChannelSensor($vo);
$sensors[] = new FTSEfficiencySensor($vo);
$sensors[] = new FTSJobSensor($vo);
$sensors[] = new FTSBDIISensor();


  foreach ($sensors as $sensor) {
    try {
      $start=time();
      $sensor->execute();
      ftsSyslog(sprintf("Sensor %s took %d s", $sensor->getName(), time()-$start), LOG_DEBUG);

      //foreach ($sensor->getAlarms() as $a) $alarms[] = $a;
      $alarms = array_merge($alarms, $sensor->getAlarms());
    } catch (Exception $e) {
      if ($sensor->getLink()) {
        $aln = sprintf("ERROR - <a href=\"%s\">%s</a>", 
                     $sensor->getLink(), 
                     $sensor->getName());
      } else {
        $aln = sprintf("ERROR - %s", 
                     $sensor->getName());
      }
      $alarms[] = new FTSAlarm(/*$aln,*/ $e->getMessage());
    }
  }

  // Print all alarms
  foreach ($alarms as $alarm) {
    echo $alarm->toHTML();
  }




echo "</table>"; //id="alerts"

} catch (Exception $e) {
  die('<span class="' . FTS_CSS_CLASS_ALERT . '">ERROR: --' . $e->getMessage() . '--</span>');
}

//echo '<h3>Configuration</h3>';
/*
echo "<a href=\"fts.php";
if ($vo != FTS_ALL) echo "?vo=" . $vo;
echo "\">Go to channels list</a>";

echo '<br>';
echo '<a href="ftsagent.php">Go to agents list</a>';
echo '<br>';
echo '<a href="ftsaudit.php">Go to history of channel management</a>';
*/
echo '<!--End of general line-->';
//echo '</tr>';
echo '<!--End of general table-->';
//echo '</table>';
echo '</div>';
//echo '</center>';
echo '</div>';
echo '</div>';
footer();
?>